SystemOrganization addCategory: #'CalmoPuzzleDemo-Harness'!
SystemOrganization addCategory: #'CalmoPuzzleDemo-Worlds'!

TCube subclass: #TPuzzleCube
	instanceVariableNames: 'norm selectedPoint baseColor empty'
	classVariableNames: 'Cube17'
	poolDictionaries: ''
	category: 'CalmoPuzzleDemo-Worlds'!

!TPuzzleCube methodsFor: 'as yet unclassified' stamp: 'gzs 6/3/2007 19:02'!
cubesRandom

	| count rnd cube up down left right cubesOc |

	cubesOc := OrderedCollection new.

	cubesOc add: Cube1.
	cubesOc add: Cube2.
	cubesOc add: Cube3.
	cubesOc add: Cube4.
	cubesOc add: Cube5.
	cubesOc add: Cube6.
	cubesOc add: Cube7.
	cubesOc add: Cube8.
	cubesOc add: Cube9.
	cubesOc add: Cube10.
	cubesOc add: Cube11.
	cubesOc add: Cube12.
	cubesOc add: Cube13.
	cubesOc add: Cube14.
	cubesOc add: Cube15.

	count := 0.

	[ count < 100 ] whileTrue: [
					rnd := 15 atRandom.
					cube := cubesOc at: rnd.

					up := (cube empty = (cube objectName + 4)).
					down := (cube empty = (cube objectName - 4)).
					left := ((cube empty = (cube objectName - 1)) & ((cube objectName\\4)~=1)).
					right := ((cube empty = (cube objectName + 1)) & ((cube objectName\\4)~=0)).

					up ifTrue: [cube translation: cube translation + (0.0@-1.5@0.0).
						self setEmpty: cube objectName.
						cube objectName: cube objectName + 4.
						count := count + 1.].					

					down ifTrue: [cube translation: cube translation + (0.0@1.5@0.0).
						self setEmpty: cube objectName.
						cube objectName: cube objectName - 4.
						count := count + 1.].					

					left ifTrue: [cube translation: cube translation + (-1.5@0.0@0.0).
						self setEmpty: cube objectName.
						cube objectName: cube objectName - 1.
						count := count + 1.].					

					right ifTrue: [cube translation: cube translation + (1.5@0.0@0.0).
						self setEmpty: cube objectName.
						cube objectName: cube objectName + 1.
						count := count + 1.].].					
! !

!TPuzzleCube methodsFor: 'as yet unclassified' stamp: 'gzs 5/25/2006 13:22'!
empty

	^ empty.! !

!TPuzzleCube methodsFor: 'as yet unclassified' stamp: 'gzs 5/25/2006 13:23'!
empty: newEmpty

	empty := newEmpty.! !

!TPuzzleCube methodsFor: 'events' stamp: 'gzs 5/25/2006 13:23'!
eventMask

	^ EventPointerOver bitOr: EventPointerDown.! !

!TPuzzleCube methodsFor: 'as yet unclassified' stamp: 'gzs 5/25/2006 13:23'!
hoorayCube

	| cube pic17 xc yc zc cr cg cb |

	pic17 := TTexture new initializeWithFileName: 'hooray.jpg' mipmap: true shrinkFit: false.

	cube := TPuzzleCube new.
	cube rotationAroundY:15.

	xc := 1.5.
	yc := -3.0.
	zc := -4.5.
	cube translation: xc@yc@zc.

	cr := 0.75.
	cg := 0.75.
	cb := 0.75.
	cube setColor: (VectorColor r:cr g:cg b:cb a:1.0).
	cube objectName: 17.

	Smalltalk at: #Cube17 put: cube. cube texture: pic17.

	PuzzleSpace addChild: cube.
! !

!TPuzzleCube methodsFor: 'as yet unclassified' stamp: 'gzs 6/3/2007 18:48'!
isEnd

	(Cube1 objectName ~= 1) ifTrue: [^false].
	(Cube2 objectName ~= 2) ifTrue: [^false].
	(Cube3 objectName ~= 3) ifTrue: [^false].
	(Cube4 objectName ~= 4) ifTrue: [^false].
	(Cube5 objectName ~= 5) ifTrue: [^false].
	(Cube6 objectName ~= 6) ifTrue: [^false].
	(Cube7 objectName ~= 7) ifTrue: [^false].
	(Cube8 objectName ~= 8) ifTrue: [^false].
	(Cube9 objectName ~= 9) ifTrue: [^false].
	(Cube10 objectName ~= 10) ifTrue: [^false].
	(Cube11 objectName ~= 11) ifTrue: [^false].
	(Cube12 objectName ~= 12) ifTrue: [^false].
	(Cube13 objectName ~= 13) ifTrue: [^false].
	(Cube14 objectName ~= 14) ifTrue: [^false].
	(Cube15 objectName ~= 15) ifTrue: [^false].

	^true.
! !

!TPuzzleCube methodsFor: 'events' stamp: 'gzs 6/3/2007 16:48'!
pointerDown: event

	| up down left right hooray over go |

	selectedPoint := event selection point.
	norm := event selection normal.
	self hilite: TButton downColor.
	
	over := self isEnd.
	up := (empty = (objectName - 4)).
	down := (empty = (objectName + 4)) & (over=false).
	left := ((empty = (objectName - 1)) & ((objectName\\4)~=1)).
	right := ((empty = (objectName + 1)) & ((objectName\\4)~=0)) & (over=false).
	hooray := (objectName = 17).
	go := (up | down | left | right | hooray).

	(go) ifTrue: [

		hooray ifTrue: [self cubesRandom. Cube17 destroy.].

		up ifTrue: [self translation: self translation + (0.0@1.5@0.0).
			self setEmpty: objectName.
			objectName := objectName - 4.].

		down ifTrue: [self translation: self translation + (0.0@-1.5@0.0).
			self setEmpty: objectName.
			objectName := objectName + 4.].

		left ifTrue: [self translation: self translation + (-1.5@0.0@0.0).
			self setEmpty: objectName.
			objectName := objectName - 1.].

		right ifTrue: [self translation: self translation + (1.5@0.0@0.0).
			self setEmpty: objectName.
			objectName := objectName + 1.].

		over := self isEnd.
		(over) ifTrue: [self hoorayCube.].
	].! !

!TPuzzleCube methodsFor: 'events' stamp: 'gzs 6/3/2007 16:41'!
pointerEnter: event

   self hilite: TButton overColor.! !

!TPuzzleCube methodsFor: 'events' stamp: 'gzs 6/3/2007 16:44'!
pointerLeave: event

	self unhilite.! !

!TPuzzleCube methodsFor: 'events' stamp: 'gzs 5/25/2006 13:24'!
pointerMove: event

"
	| delta  pointer |
	pointer := event makePointer.
	(pointer frame: self pickPlane: selectedPoint normal: norm) ifTrue:[
		delta := selectedPoint - pointer selectedPoint.
		self translation: self translation - delta.
	].
"! !

!TPuzzleCube methodsFor: 'events' stamp: 'gzs 6/3/2007 16:50'!
pointerUp: event

   self unhilite.! !

!TPuzzleCube methodsFor: 'accessing' stamp: 'gzs 5/25/2006 13:24'!
setColor: bc

	| mat |

	mat := TMaterial new.
	mat color: bc.
	self material: mat.
	baseColor := bc.
! !

!TPuzzleCube methodsFor: 'as yet unclassified' stamp: 'gzs 5/25/2006 13:24'!
setEmpty: newEmpty

	Cube1 empty: newEmpty.
	Cube2 empty: newEmpty.
	Cube3 empty: newEmpty.
	Cube4 empty: newEmpty.
	Cube5 empty: newEmpty.
	Cube6 empty: newEmpty.
	Cube7 empty: newEmpty.
	Cube8 empty: newEmpty.
	Cube9 empty: newEmpty.
	Cube10 empty: newEmpty.
	Cube11 empty: newEmpty.
	Cube12 empty: newEmpty.
	Cube13 empty: newEmpty.
	Cube14 empty: newEmpty.
	Cube15 empty: newEmpty.
	Cube16 empty: newEmpty.! !

BaseWorld subclass: #CalmoPuzzleWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CalmoPuzzleDemo-Worlds'!

!CalmoPuzzleWorld class methodsFor: 'identity' stamp: 'gzs 5/25/2006 13:21'!
islandID
	^TObjectID new
! !

!CalmoPuzzleWorld methodsFor: 'initialize' stamp: 'gzs 6/3/2007 19:02'!
cubesRandom: cubesOc

	| count rnd cube up down left right |

	count := 0.

	[ count < 100 ] whileTrue: [
					rnd := 15 atRandom.
					cube := cubesOc at: rnd.

					up := (cube empty = (cube objectName + 4)).
					down := (cube empty = (cube objectName - 4)).
					left := ((cube empty = (cube objectName - 1)) & ((cube objectName\\4)~=1)).
					right := ((cube empty = (cube objectName + 1)) & ((cube objectName\\4)~=0)).

					up ifTrue: [cube translation: cube translation + (0.0@-1.5@0.0).
						self setEmpty: cube objectName.
						cube objectName: cube objectName + 4.
						count := count + 1.].					

					down ifTrue: [cube translation: cube translation + (0.0@1.5@0.0).
						self setEmpty: cube objectName.
						cube objectName: cube objectName - 4.
						count := count + 1.].					

					left ifTrue: [cube translation: cube translation + (-1.5@0.0@0.0).
						self setEmpty: cube objectName.
						cube objectName: cube objectName - 1.
						count := count + 1.].					

					right ifTrue: [cube translation: cube translation + (1.5@0.0@0.0).
						self setEmpty: cube objectName.
						cube objectName: cube objectName + 1.
						count := count + 1.].].					

! !

!CalmoPuzzleWorld methodsFor: 'initialize' stamp: 'gzs 5/25/2006 13:20'!
initialize

	| space sky floor |

	space := TSpace new.
	Smalltalk at: #PuzzleSpace put: space.
	space registerGlobal: #mainEntry.
	self makeLight: space.
	floor := self makeFloor: space fileName: 'checker.bmp'.
	floor extentX: 400 y:0.5 z: 400.
	sky := TSkyBox new initializeWithFileName: 'ROV'.
	sky step. "get going"
	space addChild: sky.
	self makeCubes: space.! !

!CalmoPuzzleWorld methodsFor: 'initialize' stamp: 'gzs 5/25/2006 13:20'!
makeCubes: sp 

	| number count cube pic1 pic2 pic3 pic4 pic5 pic6 pic7 pic8 pic9 pic10 pic11 pic12 pic13 pic14 pic15 pic16 xc yc zc cr cg cb cubeOc |

	cubeOc := OrderedCollection new.

	pic1 := TTexture new initializeWithFileName: 'n1.jpg' mipmap: true shrinkFit: false.
	pic2 := TTexture new initializeWithFileName: 'n2.jpg' mipmap: true shrinkFit: false.
	pic3 := TTexture new initializeWithFileName: 'n3.jpg' mipmap: true shrinkFit: false.
	pic4 := TTexture new initializeWithFileName: 'n4.jpg' mipmap: true shrinkFit: false.
	pic5 := TTexture new initializeWithFileName: 'n5.jpg' mipmap: true shrinkFit: false.
	pic6 := TTexture new initializeWithFileName: 'n6.jpg' mipmap: true shrinkFit: false.
	pic7 := TTexture new initializeWithFileName: 'n7.jpg' mipmap: true shrinkFit: false.
	pic8 := TTexture new initializeWithFileName: 'n8.jpg' mipmap: true shrinkFit: false.
	pic9 := TTexture new initializeWithFileName: 'n9.jpg' mipmap: true shrinkFit: false.
	pic10 := TTexture new initializeWithFileName: 'n10.jpg' mipmap: true shrinkFit: false.
	pic11 := TTexture new initializeWithFileName: 'n11.jpg' mipmap: true shrinkFit: false.
	pic12 := TTexture new initializeWithFileName: 'n12.jpg' mipmap: true shrinkFit: false.
	pic13 := TTexture new initializeWithFileName: 'n13.jpg' mipmap: true shrinkFit: false.
	pic14 := TTexture new initializeWithFileName: 'n14.jpg' mipmap: true shrinkFit: false.
	pic15 := TTexture new initializeWithFileName: 'n15.jpg' mipmap: true shrinkFit: false.
	pic16 := TTexture new initializeWithFileName: 'n16.jpg' mipmap: true shrinkFit: false.

	number := 4.
	count := 1.
	1 to: number do:[:j |
		1 to: number do:[:i |
			1 to: (number-3) do:[:k|
				cube := TPuzzleCube new.
				cube empty: 16.
				cube rotationAroundY:15.

				xc := (((i-1)*1.5)-3).
				yc := 4.5-(((j-1)*1.5)+3).
				zc := -4.5.
				cube translation: xc@yc@zc.

				cr := number-i/number asFloat.
				cg := number-j/number asFloat.
				cb := number-k/number asFloat.
				cube setColor: (VectorColor r:cr g:cg b:cb a:1.0).

				cube objectName: count.

				(count = 1) ifTrue: [Smalltalk at: #Cube1 put: cube. cube texture: pic1.].
				(count = 2) ifTrue: [Smalltalk at: #Cube2 put: cube. cube texture: pic2.].
				(count = 3) ifTrue: [Smalltalk at: #Cube3 put: cube. cube texture: pic3.].
				(count = 4) ifTrue: [Smalltalk at: #Cube4 put: cube. cube texture: pic4.].
				(count = 5) ifTrue: [Smalltalk at: #Cube5 put: cube. cube texture: pic5.].
				(count = 6) ifTrue: [Smalltalk at: #Cube6 put: cube. cube texture: pic6.].
				(count = 7) ifTrue: [Smalltalk at: #Cube7 put: cube. cube texture: pic7.].
				(count = 8) ifTrue: [Smalltalk at: #Cube8 put: cube. cube texture: pic8.].
				(count = 9) ifTrue: [Smalltalk at: #Cube9 put: cube. cube texture: pic9.].
				(count = 10) ifTrue: [Smalltalk at: #Cube10 put: cube. cube texture: pic10.].
				(count = 11) ifTrue: [Smalltalk at: #Cube11 put: cube. cube texture: pic11.].
				(count = 12) ifTrue: [Smalltalk at: #Cube12 put: cube. cube texture: pic12.].
				(count = 13) ifTrue: [Smalltalk at: #Cube13 put: cube. cube texture: pic13.].
				(count = 14) ifTrue: [Smalltalk at: #Cube14 put: cube. cube texture: pic14.].
				(count = 15) ifTrue: [Smalltalk at: #Cube15 put: cube. cube texture: pic15.].
				(count = 16) ifTrue: [Smalltalk at: #Cube16 put: cube. cube texture: pic16.].
				
				cubeOc add: cube.

				count < 16 ifTrue: [sp addChild: cube.].
				count := count+1.
			].
		].
	].

	self cubesRandom: cubeOc.
! !

!CalmoPuzzleWorld methodsFor: 'initialize' stamp: 'gzs 5/25/2006 13:21'!
makeLight: sp

	| light tframe |

	light := TLight new.
	tframe := TSpinner new.
	tframe translationX: -10 y:0.0 z: 0.0.
	tframe rotationAroundZ: 120.
	"This is to avoid some odd lighting effects"
	tframe rotateBy: 1 around: 1@0@0.
	tframe matNil.
	tframe contents: light.
	sp addChild: tframe.! !

!CalmoPuzzleWorld methodsFor: 'initialize' stamp: 'gzs 5/25/2006 13:21'!
setEmpty: newEmpty

	Cube1 empty: newEmpty.
	Cube2 empty: newEmpty.
	Cube3 empty: newEmpty.
	Cube4 empty: newEmpty.
	Cube5 empty: newEmpty.
	Cube6 empty: newEmpty.
	Cube7 empty: newEmpty.
	Cube8 empty: newEmpty.
	Cube9 empty: newEmpty.
	Cube10 empty: newEmpty.
	Cube11 empty: newEmpty.
	Cube12 empty: newEmpty.
	Cube13 empty: newEmpty.
	Cube14 empty: newEmpty.
	Cube15 empty: newEmpty.
	Cube16 empty: newEmpty.! !

CroquetParticipantWithMenu subclass: #CalmoPuzzleMaster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CalmoPuzzleDemo-Harness'!

!CalmoPuzzleMaster class methodsFor: 'parts bin' stamp: 'gzs 5/25/2006 13:29'!
descriptionForPartsBin
	^ self partName:	'CalmoPuzzleDemo (Master)'
		categories:		#('Croquet')
		documentation:	'15-Puzzle Game'
		sampleImageForm: self defaultForm.
! !

!CalmoPuzzleMaster methodsFor: 'initialization' stamp: 'gzs 5/25/2006 13:22'!
registerPortal: portalName in: island
	| entry pc |
	entry := island future at: portalName.
	pc := entry future postcard.
	pc whenResolved:[harness addIsland: island postcard: pc value.].
	^entry! !

!CalmoPuzzleMaster methodsFor: 'initialization' stamp: 'gzs 5/25/2006 13:22'!
setup
	| pc sync entry island postcard myName |

	harness := CroquetHarnessWithMenu new.
	harness addOverlay: self.

	myName := 'Calmo Puzzle World (',NetNameResolver localHostName,')'.
	island := harness createIsland: CalmoPuzzleWorld named: myName.
	entry := self registerPortal: #mainEntry in: island.
	harness makeSnapshot: (island future at: #mainEntry) angle: 0 
		translation:(Vector3 x: 0 y: 0 z: 0).
	postcard := TPostcard new routerAddress: nil "don't know what it is"
				id: nil "don't know what it is"
				name: myName 
				viewpointName: #mainEntry.
	harness viewPortal future postcardLink: postcard.
	harness findViewpointByPostcard: postcard.

	"Drop into the intro world"
	pc := entry future postcard.
	pc whenResolved:[
		sync := harness  viewPortal future postcardLink: pc value.
		sync whenResolved:[harness startRender]. "ready to render"
	].
	pc wait.
! !
